package com.aoc.psisclient.samples;

import java.io.FileInputStream;
import java.io.InputStream;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;

import org.w3.x2000.x09.xmldsig.X509DataType;

import x0CoreSchema.oasisNamesTcDss1.SignatureObjectType;
import x0CoreSchema.oasisNamesTcDss1.SignatureObjectType.Other;
import x0CoreSchema.oasisNamesTcDss1.VerifyRequestDocument;
import x0CoreSchema.oasisNamesTcDss1.VerifyRequestDocument.VerifyRequest;
import x0CoreSchema.oasisNamesTcDss1.VerifyResponseDocument;

import com.aoc.psisclient.base.AbstractSample;

public class CertificateValidationSample extends AbstractSample{

	public static void main(String[] args){	
		try {
			CertificateValidationSample validation = new CertificateValidationSample();
			FileInputStream fis = new FileInputStream("src\\certificates\\CDA-1_00.cer");
			validation.checkCertificateAndShowRessult(fis);
		}
		catch(Exception e){
			System.out.print(e);
		}
	}

	private void checkCertificateAndShowRessult(InputStream is) throws CertificateException{
		VerifyResponseDocument response = verifyCertificate(is);
		if(isRessultWellFormed(response)){
			showMinorMajorRessult(response);
			showOptionalOutputs(response);
		}
	}

	public VerifyResponseDocument verifyCertificate(InputStream is) throws CertificateException{
		this.log.debug("Start validation "+XML_PROFILE);
		VerifyResponseDocument response = null;
		VerifyRequest request = VerifyRequest.Factory.newInstance();
		request.setProfile(XML_PROFILE);
		SignatureObjectType signatureObjectType = SignatureObjectType.Factory.newInstance();

		Other any = Other.Factory.newInstance();

		X509DataType x509DataType = X509DataType.Factory.newInstance();
		CertificateFactory cf = CertificateFactory.getInstance("X.509");
		this.log.debug("Start loading certificate");
		Certificate cert = cf.generateCertificate(is);

		this.log.debug("Start encoding certificate");
		x509DataType.addNewX509Certificate().setByteArrayValue(cert.getEncoded());
		any.setX509Data(x509DataType);
		signatureObjectType.setOther(any);

		request.setSignatureObject(signatureObjectType);

		VerifyRequestDocument verifyRequest = VerifyRequestDocument.Factory.newInstance();
		verifyRequest.setVerifyRequest(request);
		this.log.debug("Send request XML verification");
		response = this.factory.getDssPort().verify(verifyRequest);
		return response;
	}
}
